/**
 * The counterpart for DOMProxy.as
 *
 */
 
if(typeof HURLANT=="undefined"||!HURLANT){var HURLANT={};}

HURLANT.jsobject = (function(){
	var refs = {};
	var idcount=0;
	var flo = null;

	function genId(obj) {
	  // heavy.
	  for (var a in refs) {
	  	if (refs[a]===obj)
	  		return a;
	  }
	  var id = "obj"+(idcount++);
	//  alert("new ID="+id+" for "+obj)
	  refs[id] = obj;
	  return id;
	}
	
	function resolve(o) {
		if (o==null) return o;
		switch(o.type) {
			case "ref":
				var val = refs[o.id];
				break;
			case "func":
				var val = resolveFunction(o.id);
				break;
			case "value":
				var val = o.val;
				break;
		}
		return val;
	}
	function resolveFunction(id) {
		var o = flo;
		var f = function() {
			var a=arguments;
			var b = [];
			for (var i=0;i<a.length;i++) {
				b[i] = returnRef(a[0]);
			}
			var v = o.call(id, returnRef(this), b);
			return resolve(v);
		};
		return f;
	}
	function returnRef(obj) {
	  var t = typeof obj;
	  if (t=="number"||t=="string"||t=="boolean"||t==null) {
	  	return {value:obj};
	  }
	  var id = genId(obj);
	  if (t=="function") {
		return {id:id, callable:true};
	  } else {
		return {id:id};
	  }
	}
	
	function callRefByValue(name, parent, args) {
		parent = refs[parent];
		var obj = parent[name].apply(parent, args);
		return returnRef(obj);
	};
	
	HURLANT_jsobject_setup = function setup(id) {
			flo = document.getElementById(id);
	};
	HURLANT_jsobject_getReference = function getReference(name, parent) {
	  if (parent==null) { 
	    parent=window;
	  } else {
	    parent = refs[parent];
	  }
	  var obj = parent[name];
	  return returnRef(obj);
	};
	HURLANT_jsobject_setRef = function setRef(name, parent, o) {
		parent = refs[parent];
		parent[name] = resolve(o);
	};
	HURLANT_jsobject_callRefById = function callRefById(name, parent, args) {
		for (var i=0;i<args.length;i++) {
			var a = args[i];
			if (typeof a == "string") {
				args[i] = refs[a];
			} else {
				args[i] = a[0];
			}
		}
		return callRefByValue(name, parent, args);
	};
	HURLANT_jsobject_callRefByValue = callRefByValue;
	HURLANT_jsobject_delReference = function delReference(name, parent) {
		parent = refs[parent];
		try {
			return delete parent[name];
		} catch (e) {
			return false;
		}
	};
	HURLANT_jsobject_hasReference = function hasReference(name, parent) {
		parent = refs[parent];
		return (typeof parent[name] != "undefined"); // not 100% correct, but close enough.
	};
	HURLANT_jsobject_getIndexes = function getIndexes(parent) {
		parent = refs[parent];
		var items = [];
		for (var x in parent) {
			items.push(x);
		}
		return items;
	};
	HURLANT_jsobject_callRef = function callRef(ref, args) {
		ref = refs[ref];
		ref.apply(this, args);
	};
})();
